outlets = 2;

var g = new Global("globaljs");
var patchnum = 0;
var x, y;
var xwdith, ywidth;
var destx, desty;
var startx, starty;


function setpatchnum(pnum)
{
	patchnum = pnum;
}

function setxy()
{
	x = g.basex + g.xlocs0[patchnum-1];
	y = g.basey + g.ylocs0[patchnum-1];
	xwidth = 30;
	ywidth = 30;

	outlet(0, x, y, x+xwidth, y+ywidth);
}

function destxy_default()
{
	destx = g.basex + g.xlocs0[patchnum-1];
	desty = g.basey + g.ylocs0[patchnum-1];
	startx = x;
	starty = y;
}

function destxy_dragon()
{
	// 550 and 150 are the base loc offsets from corner of main window
	destx = g.basex + g.xlocs1[patchnum-1] - 550;
	if (destx < 0 ) destx = 0;
	desty = g.basey + g.ylocs1[patchnum-1] - 150;
	if (desty < 0) desty = 0;
	startx = x;
	starty = y;
}

function destxy_incandescent()
{
	destx = g.basex + g.xlocs2[patchnum-1];
	desty = g.basey + g.ylocs2[patchnum-1];
	startx = x;
	starty = y;
}

function destxy_adventure()
{
	destx = g.basex + g.xlocs3[patchnum-1];
	desty = g.basey + g.ylocs3[patchnum-1];
	startx = x;
	starty = y;
}

function destxy_adventurea()
{
	destx = g.basex + g.xlocs3a[patchnum-1];
	desty = g.basey + g.ylocs3a[patchnum-1];
	startx = x;
	starty = y;
}

function destxy_swimfly()
{
	destx = g.basex + g.xlocs4[patchnum-1];
	desty = g.basey + g.ylocs4[patchnum-1];
	startx = x;
	starty = y;
}

function destxy_cinnamon()
{
	destx = g.basex + g.xlocs5[patchnum-1];
	desty = g.basey + g.ylocs5[patchnum-1];
	startx = x;
	starty = y;
}

function destxy_whitehorses()
{
	destx = g.basex + g.xlocs6[patchnum-1];
	desty = g.basey + g.ylocs6[patchnum-1];
	startx = x;
	starty = y;
}

function destxy_metadream()
{
	destx = g.basex + g.xlocs7[patchnum-1];
	desty = g.basey + g.ylocs7[patchnum-1];
	startx = x;
	starty = y;
}


function destxy_machinery()
{
//	destx = g.basex + g.xlocs8[patchnum-1];
//	desty = g.basey + g.ylocs8[patchnum-1];
	desty = g.basey + Math.floor(Math.random() * 650.0 - 250.0);
	if ( (desty > g.basey-210) && (desty < g.basey+250) )
		destx = g.basex + Math.floor(Math.random() * 230.0 - 30.0);
	else
		destx = g.basex + Math.floor(Math.random() * 800.0 - 600.0);
	startx = x;
	starty = y;
}

function destxy_crystal()
{
	destx = g.basex + g.xlocs9[patchnum-1];
	desty = g.basey + g.ylocs9[patchnum-1];
	startx = x;
	starty = y;
}

function destxy_italy()
{
	destx = g.basex + g.xlocs10[patchnum-1];
	desty = g.basey + Math.floor(Math.random() * 25.0 + 300.0);
	startx = x;
	starty = y;
}

function destxy_goodbad()
{
	destx = g.basex + g.xlocs11[patchnum-1];
	desty = g.basey + g.ylocs11[patchnum-1];
	startx = x;
	starty = y;
}

function destxy_people()
{
	destx = g.basex + g.xlocs12[patchnum-1];
	desty = g.basey + g.ylocs12[patchnum-1];
	startx = x;
	starty = y;
}

function destxy_emotion()
{
	destx = g.basex + g.xlocs13[patchnum-1];
	desty = g.basey + g.ylocs13[patchnum-1];
	startx = x;
	starty = y;
}

function destxy_happy()
{
	destx = g.basex + g.xlocs14[patchnum-1];
	desty = g.basey + g.ylocs14[patchnum-1];
	startx = x;
	starty = y;
}

function msg_int(ival) // [0, 100 time] -> [line]
{
	if ( ((destx-startx) != 0) || ((desty-starty) != 0) ) {
		x = startx + ((destx - startx) * ival/100);
		y = starty + ((desty - starty) * ival/100);

		outlet(1, Math.floor(x), Math.floor(y), Math.floor(x)+xwidth, Math.floor(y)+ywidth);
	}
}